# coding: utf-8

"""
    REST API

    Rockset's REST API allows for creating and managing all resources in Rockset. Each supported endpoint is documented below.  All requests must be authorized with a Rockset API key, which can be created in the [Rockset console](https://console.rockset.com). The API key must be provided as `ApiKey <api_key>` in the `Authorization` request header. For example: ``` Authorization: ApiKey aB35kDjg93J5nsf4GjwMeErAVd832F7ad4vhsW1S02kfZiab42sTsfW5Sxt25asT ```  All endpoints are only accessible via https.  Build something awesome!  # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from rockset.swagger_client.models.saved_query_parameter import SavedQueryParameter  # noqa: F401,E501


class CreateSavedQueryRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'version_tag': 'str',
        'query_sql': 'str',
        'parameters': 'list[SavedQueryParameter]'
    }

    attribute_map = {
        'name': 'name',
        'version_tag': 'version_tag',
        'query_sql': 'query_sql',
        'parameters': 'parameters'
    }

    def __init__(self, name, query_sql, **kwargs):  # noqa: E501
        """CreateSavedQueryRequest - a model defined in Swagger"""  # noqa: E501

        self._name = None
        self._version_tag = None
        self._query_sql = None
        self._parameters = None
        self.discriminator = None

        self.name = name
        self.version_tag = kwargs.pop('version_tag', None)
        self.query_sql = query_sql
        self.parameters = kwargs.pop('parameters', None)

    @property
    def name(self):
        """Gets the name of this CreateSavedQueryRequest.  # noqa: E501

        query name  # noqa: E501

        :return: The name of this CreateSavedQueryRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CreateSavedQueryRequest.

        query name  # noqa: E501

        :param name: The name of this CreateSavedQueryRequest.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def version_tag(self):
        """Gets the version_tag of this CreateSavedQueryRequest.  # noqa: E501

        optional version tag  # noqa: E501

        :return: The version_tag of this CreateSavedQueryRequest.  # noqa: E501
        :rtype: str
        """
        return self._version_tag

    @version_tag.setter
    def version_tag(self, version_tag):
        """Sets the version_tag of this CreateSavedQueryRequest.

        optional version tag  # noqa: E501

        :param version_tag: The version_tag of this CreateSavedQueryRequest.  # noqa: E501
        :type: str
        """

        self._version_tag = version_tag

    @property
    def query_sql(self):
        """Gets the query_sql of this CreateSavedQueryRequest.  # noqa: E501

        SQL text of this query  # noqa: E501

        :return: The query_sql of this CreateSavedQueryRequest.  # noqa: E501
        :rtype: str
        """
        return self._query_sql

    @query_sql.setter
    def query_sql(self, query_sql):
        """Sets the query_sql of this CreateSavedQueryRequest.

        SQL text of this query  # noqa: E501

        :param query_sql: The query_sql of this CreateSavedQueryRequest.  # noqa: E501
        :type: str
        """

        self._query_sql = query_sql

    @property
    def parameters(self):
        """Gets the parameters of this CreateSavedQueryRequest.  # noqa: E501

        parameters associated with this query  # noqa: E501

        :return: The parameters of this CreateSavedQueryRequest.  # noqa: E501
        :rtype: list[SavedQueryParameter]
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """Sets the parameters of this CreateSavedQueryRequest.

        parameters associated with this query  # noqa: E501

        :param parameters: The parameters of this CreateSavedQueryRequest.  # noqa: E501
        :type: list[SavedQueryParameter]
        """

        self._parameters = parameters

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateSavedQueryRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateSavedQueryRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

    def __getitem__(self, item):
        return getattr(self, item)

    def get(self, item):
        return getattr(self, item)

    def items(self):
        return self.to_dict().items()

    def __setitem__(self, item, value):
        return seattr(self, item, value)
